import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;

/**
 * Class that represents a tailgate party and what snacks are present.
 * Stores a list of all the snacks at the tailgate and computes some
 * information about the snacks.
 * @author Stephen
 * @version 08/30/17
 */
public class Tailgate
{
    /**
     * The list of snacks in the tailgate.
     */
    private ArrayList<Snack> snacks = new ArrayList<Snack>();
    
    /**
     * Constructor, takes in a csv file of snacks and stores it.
     * @param filename The name of the csv file containing a list of snacks, one snack on each line.
     * @throws IOException
     */
    public Tailgate(String filename) throws IOException
    {
        BufferedReader br = new BufferedReader(new FileReader(filename));
        String strg;
        
        // throw out header
        strg = br.readLine(); 
        // Read the first line of data
        strg = br.readLine();
        
        // Loop over all data-containing lines
        while (strg != null)
        {
            // TODO: complete implementation
        }
        br.close();
    }
    
    /**
     * Determines if snacks are sorted in order of increasing price.
     * @return True if snacks are sorted in order of increasing price, else False.
     */
    public boolean snacksInPriceOrder()
    {
        boolean inOrder = true;
        double lastPrice = -1;
        double price = 0;
        for (int i = 0; i < snacks.size(); i++)
        {
            price = snacks.get(i).getPrice();
            if (price < lastPrice)
            {
                inOrder = false;
            }
            lastPrice = price;
        }
        return inOrder;
    }
    
    /**
     * Finds the snack with the lowest calories per serving.
     * @return A snack object that has the lowest calories per serving out of all snacks recorded.
     */
    public Snack lowestCaloriesPerServing()
    {
        // Set arbitrarily high (Snacks should not be over 1000 calories/serving, however):
        double lowestCaloriesPerServing = Double.POSITIVE_INFINITY;
        Snack lowestCalSnack = null;
        
        // Loop over all of the snacks
        for (int i = 0; i < snacks.size(); i++)
        {
            // TODO: complete implementation
        }
        return lowestCalSnack;
    }
    
    /**
     * Formats information about the snacks in the tailgate.
     * 
     * @return Various information about the tailgate:
     * -The total cost of the tailgate.
     * -The number of desserts in the tailgate.
     * -Whether or not the snacks are in order of price.
     * -The snack with the lowest calories per serving (and what its calories per serving are).
     */
    @Override
    public String toString()
    {
        String out = "";
        
        // Simple loop, adding a number:
        out += "Total Cost Of Tailgate:\n\n";
        out += computeTotalPrice();
        
        // More complex loop with Conditionals:
        out += "\n\nNumber Of Desserts:\n\n";
        out += numberOfDesserts();
        
        // Comparing elements of list in series, tracking condition:
        out += "\n\nSnacks In Price Order:\n\n";
        out += snacksInPriceOrder();
        
        // Finding min/max value, tracking index:
        out += "\n\nSnack With Lowest Calories Per Serving:\n\n";
        out += lowestCaloriesPerServing().toString();
        
        return out;
    }
}
